/*
 * CompanyUsersListener.java
 *
 * Created on 10 de agosto de 2004, 18:10
 */

package com.fenalco.servlets.supplier;

import java.io.IOException;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import com.fenalco.entities.User;
import com.fenalco.utilities.MessageBuilder;

/**
 * Ese servlet identifica la petición realizada por <CODE>usuariosempresa.jsp
 * </CODE> sobre el listado de usuarios: nuevo, modificar, eliminar y toma las
 * acciones necesarias, que corresponden a redireccionar al usuario por el
 * camino adecuado.
 * 
 * @author andres
 */
public class CompanyUsersListener extends HttpServlet
{

	/**
	 * Inicializa el servlet.
	 * 
	 * @param config
	 *            Parámetro de configuración
	 * @throws ServletException
	 *             Excepción de fallo en la operación de inicialización
	 */
	public void init( ServletConfig config ) throws ServletException
	{
		super.init(config);

	}

	/**
	 * Destruye el servlet.
	 */
	public void destroy( )
	{

	}

	/**
	 * Procesa las peticiones a los métodos HTTP <code>GET</code> y
	 * <code>POST</code>.
	 * 
	 * Este método realiza la acción apropiada de acuerdo a la petición
	 * recibida, que viene encapsulada en el parametro "operationType": - nuevo:
	 * "new" redirecciona a <CODE>nuevousuario.jsp</CODE>- modificar:
	 * "update" redirecciona a <CODE>modificarusuario.jsp</CODE>. - eliminar:
	 * "delete" redirecciona la servlet <CODE>administrarusuariosempresa
	 * </CODE> enviando la petición de eliminación con el identificador del
	 * usuario a eliminar
	 * 
	 * @param request
	 *            Petición al servlet
	 * @param response
	 *            Respuesta al servlet
	 * @throws ServletException
	 *             Excepción de fallo en la operación de procesamiento de
	 *             peticiones
	 * @throws IOException
	 *             Excepción de fallo enla operación de escritura con el flujo
	 *             <CODE>PrintWriter</CODE> de response.
	 */
	protected void processRequest( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		HttpSession session = request.getSession(false);
		RequestDispatcher dispatcher;
		String url = "";
		String message = "";

	    try
	    {
	        if( session == null || ( User )session.getAttribute( "user" ) == null || ( ( User )session.getAttribute( "user" ) ).getRoleId() != 2 )
			{
				url = "/logout";
				//message = "Sesión no iniciada";
				message = MessageBuilder.buildMessage(15);
			}
			else
			{
				String operationType = request.getParameter("operationType");
	
				if( operationType.equals("new") )
				{
					url = "/proveedor/nuevousuario.jsp";
	
				}
				else
					if( operationType.equals("update") )
					{
						url = "/proveedor/modificarusuario.jsp";
						String userId = request.getParameter("key");
						User supplierUser = new User(userId);
						request.setAttribute("user", supplierUser);
	
					}
					else
						if( operationType.equals("delete") )
						{
							url = "/proveedor/administrarusuariosempresa";
						}
			}
	    }
	    catch( Exception e )
	    {
	        url="/logout";
	        message = MessageBuilder.buildMessage(15);
	    }

		request.setAttribute("message", message);
		dispatcher = getServletContext().getRequestDispatcher(url);
		dispatcher.forward(request, response);
	}

	/**
	 * Maneja el método HTTP <code>GET</code>.
	 * 
	 * @param request
	 *            Petición al servlet
	 * @param response
	 *            Respuesta al servlet
	 * @throws ServletException
	 *             Excepción de fallo en la operación de procesamiento de
	 *             peticiones
	 * @throws IOException
	 *             Excepción de fallo enla operación de escritura con el flujo
	 *             <CODE>PrintWriter</CODE> de response.
	 */
	protected void doGet( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Maneja el método HTTP <code>POST</code>.
	 * 
	 * @param request
	 *            Petición al servlet
	 * @param response
	 *            Respuesta al servlet
	 * @throws ServletException
	 *             Excepción de fallo en la operación de procesamiento de
	 *             peticiones
	 * @throws IOException
	 *             Excepción de fallo enla operación de escritura con el flujo
	 *             <CODE>PrintWriter</CODE> de response.
	 */
	protected void doPost( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Información general del servlet.
	 * 
	 * @return Retorna una descripción general del servlet.
	 */
	public String getServletInfo( )
	{
		return "Short description";
	}

}